#!/bin/sh

CVSROOT=~/cvsroot
RPMROOT=~/rpm
ROOT=~/firestorm-build
DIR="firestorm-0.5.4"
TAG="HEAD"

## export from CVS and cd into root
mkdir -p $ROOT
cvs -d $CVSROOT export -r $TAG -d $ROOT/$DIR firestorm
pushd $ROOT/$DIR


## Setup the source code
./autogen.sh --help

## Make the powerpc dpkg
su -c "dpkg-buildpackage && chown -R scara.scara $ROOT"

## Make the source tarball
cd ..
tar -zcf $DIR.tar.gz $DIR

## Prepare to make the RPMs
cp $DIR/firestorm.spec $RPMROOT/SPECS/
cp $DIR.tar.gz $RPMROOT/SOURCES/
pushd $RPMROOT

# Build the PPC RPMs
rpmbuild -ba --nodeps SPECS/firestorm.spec || \
	(echo "ppc rpm build failed"; exit)
rpmbuild --clean SPECS/firestorm.spec

# Build the intel RPMs
env CC=i486-redhat-linux-gcc rpmbuild -ba --nodeps \
	--target=i386-redhat-linux SPECS/firestorm.spec	|| \
	(echo "intel rpm build failed"; exit)
rpm --clean SPECS/firestorm.spec

rm -f SPECS/firestorm.spec
rm -f SOURCES/$DIR.tar.gz

mv RPMS/*/firestorm-*.rpm $ROOT
mv SRPMS/firestorm-*.rpm $ROOT

popd


## Finish up
rm -rf $ROOT/$DIR
popd
