/*
 * This file is part of tcpidx
 * Copyright (c) 2003 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
*/
#ifndef __IDX_HEADER_INCLUDED__
#define __IDX_HEADER_INCLUDED__

/* --- Index on-disk format */
#define IDX_MAGIC		0x24a9cf13
#define IDX_NAMELEN		28

/* Range of keys */
#define IDX_KEY_MIN		0
#define IDX_KEY_MAX		0xffffffff

/* Index types */
#define IDX_TYPE_ORDERED	0
#define IDX_TYPE_HASHED		1

/* External file offsets */
typedef u_int32_t idx_val_t;

/* Size of index keys */
typedef u_int32_t idx_key_t;

/* Internal index file offsets */
typedef u_int32_t idx_ofs_t;

/* First a simple header */
struct idx_hdr {
	u_int32_t magic;
	idx_ofs_t num;
};

/* then hdr.num of these */
struct idx_index {
	char name[IDX_NAMELEN];
	u_int8_t type;
	u_int8_t reserved1;
	u_int16_t reserved2;
	idx_ofs_t ofs;
	idx_ofs_t len;
	idx_ofs_t num_keys;
	idx_ofs_t num_vals;
};

struct idx_node {
	idx_key_t key;
	idx_ofs_t ofs;
	idx_ofs_t num;
};

#endif /* __IDX_HEADER_INCLUDED__ */
