#ifndef __PKT_HTTP_HEADER_INCLUDED__
#define __PKT_HTTP_HEADER_INCLUDED__

#define HTTP_REQUEST 0
#define HTTP_RESPONSE 1

#define HTTPS_HEADER	0
#define HTTPS_CONTENT	1
#define HTTPS_CHUNKED	2
#define HTTPS_CLOSING	3

/* The three version of the HTTP protocol we are expected to understand as
 * required by RFC 2616.
 */
#define HTTP_VER_UNKNOWN	0
#define HTTP_VER_0_9		1
#define HTTP_VER_1_0		2
#define HTTP_VER_1_1		3
#define HTTP_VER_MAX		4

struct http_request {
	unsigned int type;
	unsigned int proto_vers;
	struct fvec uri;
	struct fvec method;
};

struct http_response {
	unsigned int type;
	unsigned int proto_vers;
	int code;
};

struct http_fside {
	u_int16_t state;
	u_int16_t pstate;
	size_t len;
};

struct http_flow {
	struct http_fside client;
	struct http_fside server;
};

/* For backwards compat */
struct http_serial {
	u_int32_t uri;
	u_int32_t uri_len;
	u_int32_t method;
	u_int32_t method_len;
};

struct http_serial_req {
	u_int8_t type;
	u_int8_t vers;
	u_int16_t unused;
	u_int32_t uri;
	u_int32_t uri_len;
	u_int32_t method;
	u_int32_t method_len;
};

struct http_serial_resp {
	u_int8_t type;
	u_int8_t vers;
	u_int16_t unused;
	int32_t code;
};

#endif /* __PKT_HTTP_HEADER_INCLUDED__ */
