#ifndef __STRTOUINT_HEADER_INCLUDED__
#define __STRTOUINT_HEADER_INCLUDED__

/* Error detecting string to unsigned int conversion.
*  Return values:
*   <0 - error
*   =0 - the input string was perfect
*   >0 - the input string had trailing garbage, return
*        value tells you how many bytes were numbers.
*/
#include <limits.h>
#include <errno.h>
static inline int strtouint(const char *s, unsigned int *v)
{
	unsigned long int ret;
	char *end=NULL;

	ret=strtoul(s, &end, 0);

	if ( end==s )
		return -1;

	if ( ret == ULONG_MAX && errno==ERANGE )
		return -1;

	*v = ret;

	if ( *end == '\0' )
		return 0;

	return end - s;
}

#endif /* __STRTOUINT_HEADER_INCLUDED__ */
